/* ``The contents of this file are subject to the Erlang Public License,
 * Version 1.0, (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.erlang.org/EPL1_0.txt
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is Erlang-4.7.3, December, 1998.
 * 
 * The Initial Developer of the Original Code is Ericsson Telecom
 * AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
 * Telecom AB. All Rights Reserved.
 * 
 * Contributor(s): ______________________________________.''
 */
#ifndef _ELOG_GLOBAL_H
#define _ELOG_GLOBAL_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <process.h>

#define STRICT
#define WIN32_LEAN_AND_MEAN
#include "windows.h"

#ifdef _DEBUG
/*#define HARDDEBUG*/
#define DEBUG
#endif

/*
 * Compile time limits
 */
#define SMALLBUFSIZ 512
#define BIGBUFSIZ 2048
#define MAX_PARAM_STRINGS 200
#define MAX_FACILITY_NAME 100

/*
 * Structure containing message file names
 */
typedef struct _message_files {
  char *event;
  char *param;
} MessageFiles;

/*
 * How to get the default language
 */
#define DEFAULT_LANGID MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT)

#endif /* _ELOG_GLOBAL_H */
